<template>
  <van-col span="6">
    <!--    <van-uploader :after-read="afterRead" upload-text="照片上传"/>-->
    <div class="uploaderImage">
      <p class="coverImg" @click="uploadImg">
        <van-icon class="photo ico" name="photograph" size="16px" color="#969696"> </van-icon>
        <span>{{ imgText }}</span>
      </p>
    </div>
    <div id="allmap"></div>
  </van-col>
</template>

<script>
import { ImagePreview } from 'vant';
import { addPhotov } from '@/api/index';
import axios from 'axios';

export default {
  name: 'uploadImg',
  props: {
    uploadid: {
      type: String,
      default: '',
    },
    imgText: {
      type: String,
      default: '',
    },
    indexImg: {
      type: Number,
      default: 0,
    },
    visitsId: {
      type: String,
      default: '',
    },
    customId: {
      type: String | Number,
      default: '',
    },
    summaryId: {
      type: String | Number,
      default: '',
    },
    type: {
      type: Number,
      default: 1,
    },
    imgArr: {
      type: String,
      default: '',
    },
    // 是否补填
    allowWriteAgain: {
      type: Boolean,
      default: false,
    },
    item: {
      type: Object,
      default: {},
    },
  },
  data() {
    return {
      shows: false,
      url: '',
      addressesRemark: '',
      localIdsArr: [],
    };
  },
  methods: {
    deleteImgs(val) {
      ImagePreview([val]);
    },
    uploadImg() {
      let url = window.location.href;
      let that = this;
      let wx = this.wx;
      let qiyeData;
      this.addressesRemark = '';
      var map = new TMap.Map('allmap', {
        zoom: 14,
        center: new TMap.LatLng(39.986785, 116.301012),
      });

      var geocoder = new TMap.service.Geocoder(); // 新建一个正逆地址解析类
      var markers = new TMap.MultiMarker({
        map: map,
        geometries: [],
      });
      markers.setGeometries([]);
      const instance = axios.create();
      instance.defaults.headers.common['userId'] = localStorage.getItem('loginName');
      instance
        .get(process.env.VUE_APP_BASE_API + 'mobile/wx/ticket', {
          params: {
            url: url,
          },
        })
        .then((response) => {
          if (response.status == 200) {
            qiyeData = response.data.data;
            wx.config({
              beta: true, // 必须这么写，否则wx.invoke调用形式的jsapi会有问题
              debug: false, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
              appId: qiyeData.appId, // 必填，企业微信的corpID
              timestamp: qiyeData.timestamp, // 必填，生成签名的时间戳
              nonceStr: qiyeData.nonceStr, // 必填，生成签名的随机串
              signature: qiyeData.signature, // 必填，签名，见 附录-JS-SDK使用权限签名算法
              jsApiList: ['ready', 'chooseImage', 'uploadImage', 'getLocation'], // 必填，需要使用的JS接口列表，凡是要调用的接口都需要传进来
            });
            wx.ready(function () {
              wx.getLocation({
                type: 'gcj02',
                success: function (res) {
                  var location = new TMap.LatLng(res.latitude, res.longitude);
                  map.setCenter(location);
                  markers.updateGeometries([
                    {
                      id: 'main', // 点标注数据数组
                      position: location,
                    },
                  ]);
                  geocoder.getAddress({ location: location }).then(
                    function (result) {
                      var addresses = result.result.formatted_addresses;
                      that.addressesRemark = addresses.recommend;
                    },
                    function (err) {
                      that.addressesRemark = '';
                    }
                  );
                },
                fail: function () {
                  that.$dialog.alert({
                    message: 'GPS未开启',
                  });
                },
              });
              wx.chooseImage({
                count: 5,
                sizeType: ['compressed'], // 可以指定是原图还是压缩图，默认二者都有
                sourceType: ['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
                defaultCameraMode: 'normal', //表示进入拍照界面的默认模式，目前有normal与batch两种选择，normal表示普通单拍模式，batch表示连拍模式，不传该参数则为normal模式。从3.0.26版本开始支持front和batch_front两种值，其中front表示默认为前置摄像头单拍模式，batch_front表示默认为前置摄像头连拍模式。（注：用户进入拍照界面仍然可自由切换两种模式）
                isSaveToAlbum: 0,
                success: function (res) {
                  let localIds = res.localIds;
                  // andriod中localId可以作为img标签的src属性显示图片；
                  // iOS应当使用 getLocalImgData 获取图片base64数据，从而用于img标签的显示（在img标签内使用 wx.chooseImage 的 localid 显示可能会不成功）
                  that.localIdsArr = [];
                  that.syncUpload(localIds);
                  // wx.uploadImage({
                  //   localId: localIds, // 需要上传的图片的本地ID，由chooseImage接口获得
                  //   isShowProgressTips: 1, // 默认为1，显示进度提示
                  //   success: function (res) {
                  //     that.uploadImagev(res.serverId, addressesRemark);
                  //   },
                  // });
                },
              });
            });
          }
        });
    },
    syncUpload(localIds) {
      if (!localIds.length) {
        this.uploadImagev(this.localIdsArr);
      } else {
        var localId = localIds.pop();
        wx.uploadImage({
          localId: localId,
          isShowProgressTips: 1, // 默认为1，显示进度提示
          success: (res) => {
            this.localIdsArr.push(res.serverId);
            this.syncUpload(localIds);
          },
        });
      }
    },
    uploadImagev(meidaIds) {
      var form = {
        mediaIds: meidaIds,
        customId: this.customId,
        summaryId: this.summaryId,
        locationRemark: this.addressesRemark,
      };
      var loind1 = this.$toast.loading({
        duration: 0,
        message: '上传中...',
        forbidClick: true,
      });
      // 允许补填 添加上补填标识
      if (this.allowWriteAgain) {
        form.writeAgain = '1';
      }
      addPhotov(form).then((res) => {
        if (res.code == 200) {
          // that.imgArr = res.data.url;
          loind1.clear();
          this.$toast('上传成功！');
          let urlArr = [];
          let idArr = [];
          res.data.forEach((val) => {
            urlArr.push({
              fileUrl: val.url,
              id: val.fileId,
              // fileType: val.fileType,
              // fileName: val.fileName,
              type: this.type,
              index: this.indexImg,
            });
            idArr.push(val.fileId);
          });
          if (this.item.fileInfoList == null || this.item.fileInfoList == undefined) {
            this.item.fileInfoList = [];
            this.item.fileIdList = [];
          }
          this.item.fileInfoList = this.item.fileInfoList.concat(urlArr);
          this.item.fileIdList = this.item.fileIdList.concat(idArr);
          this.$emit('newimgarr');
        } else {
          this.$toast('上传失败！');
        }
      });
    },
  },
};
</script>

<style scoped>
.uploaderImage {
  position: relative;
  height: 80px;
  width: 80px;
  border: 1px solid #ccc;
  border-radius: 5px;
}

.uploaderImage img {
  position: absolute;
  width: 100%;
  display: block;
  height: 40px;
  top: 0;
}

.imgPre {
  height: 164px;
  width: 100%;
  background-color: white;
  border-radius: 6px;
  overflow: hidden;
}

.photos1 {
  margin: 70px auto;
  left: 50%;
  margin-left: -14px;
}

.photobrowsing {
  position: absolute;
  padding: 4px;
  right: 0;
  top: 0;
  z-index: 99;
  background-color: rgba(255, 255, 255, 0.8);
  border-bottom-left-radius: 3px;
  border-top-left-radius: 3px;
}

.uploaderImage .coverImg {
  text-align: center;
  position: absolute;
  top: 0;
  left: 0;
  height: 80px;
  margin: 0;
  width: 100%;
}
.uploaderImage .coverImg span {
  padding-top: 24px;
  display: block;
  text-align: center;
}
.uploaderImage .coverImg .ico {
  top: 30%;
}
#allmap {
  width: 10px;
  height: 10px;
  left: -1000px;
  position: relative;
}
</style>
